%global pkg xscale
%global kernel 5.10.134-19.an8
%define pkg_version 1.2.0_367
%define anolis_release 3

Name:		kmod-%{pkg}
Version:	%(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:	%{pkg_version}~%{anolis_release}%{?dist}
Summary:	Yunsilicon Roce HCA Driver
Vendor:         Yunsilicon

Group:		System Environment/Base
License:	BSD
URL:		www.yunsilicon.com
Source0:	kmod-%{pkg}-%{pkg_version}.tar.gz

BuildRequires:	gcc
BuildRequires:  kernel-headers = %{kernel}
BuildRequires:  kernel-devel = %{kernel}

Requires: kernel >= %{kernel}
Requires: kernel-headers >= %{kernel}

%define debug_package %{nil}

Provides: kmod-%{pkg}-%{kernel}.%{_arch} = %{version}-%{release}
Obsoletes: kmod-%{pkg}-%{kernel}.%{_arch} < %{version}-%{release}

%description
Yunsilicon Roce HCA Driver

%package -n %{name}-rdma
Summary:        Yunsilicon Roce HCA Driver
Requires: %{name} = %{version}-%{release}
%description -n %{name}-rdma
Yunsilicon Roce HCA Driver

%prep
%setup -q -n kmod-%{pkg}-%{pkg_version}

%build
export KSRC=/usr/src/kernels/%{kernel}.%{_arch}
export KERNEL_SRC=/usr/src/kernels/%{kernel}.%{_arch}
export BUILD_KERNEL=%{kernel}.%{_arch}
%define BUILD_CMD bash build.sh --build %{?_build_params}
pushd $RPM_BUILD_DIR/%{name}-%{pkg_version}/src; %{BUILD_CMD}; popd

%install
install -d $RPM_BUILD_ROOT/usr/src/%{name}/drivers/xsc/include/rdma
cp -r $RPM_BUILD_DIR/%{name}-%{pkg_version}/src/drivers/infiniband/hw/xsc/peer_mem.h $RPM_BUILD_ROOT/usr/src/%{name}/drivers/xsc/include/rdma/peer_mem.h

install -d $RPM_BUILD_ROOT/etc/modules-load.d/
install -m 0644 $RPM_BUILD_DIR/%{name}-%{pkg_version}/src/modules-load.d/xscale.conf $RPM_BUILD_ROOT/etc/modules-load.d/
install -m 0644 $RPM_BUILD_DIR/%{name}-%{pkg_version}/src/modules-load.d/xscale-rdma.conf $RPM_BUILD_ROOT/etc/modules-load.d/

install -d $RPM_BUILD_ROOT/lib/modules/%{kernel}.%{_arch}/extra/xsc_rdma/hw/
install -m 0755 $RPM_BUILD_DIR/%{name}-%{pkg_version}/src/drivers/infiniband/hw/xsc/xsc_ib.ko $RPM_BUILD_ROOT/lib/modules/%{kernel}.%{_arch}/extra/xsc_rdma/hw/

install -d $RPM_BUILD_ROOT/lib/modules/%{kernel}.%{_arch}/extra/xsc_net/
install -m 0755 $RPM_BUILD_DIR/%{name}-%{pkg_version}/src/drivers/net/ethernet/yunsilicon/xsc/net/xsc_eth.ko $RPM_BUILD_ROOT/lib/modules/%{kernel}.%{_arch}/extra/xsc_net/

install -d $RPM_BUILD_ROOT/lib/modules/%{kernel}.%{_arch}/extra/xsc_pci/
install -m 0755 $RPM_BUILD_DIR/%{name}-%{pkg_version}/src/drivers/net/ethernet/yunsilicon/xsc/pci/xsc_pci.ko $RPM_BUILD_ROOT/lib/modules/%{kernel}.%{_arch}/extra/xsc_pci/

install -d $RPM_BUILD_ROOT/usr/sbin/
install -m 0755 $RPM_BUILD_DIR/%{name}-%{pkg_version}/src/sbin/mcr.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 0755 $RPM_BUILD_DIR/%{name}-%{pkg_version}/src/sbin/xsc_common_irq_affinity.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 0755 $RPM_BUILD_DIR/%{name}-%{pkg_version}/src/sbin/xsc_check_irq.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 0755 $RPM_BUILD_DIR/%{name}-%{pkg_version}/src/sbin/xsc_set_irq_affinity_bynode.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 0755 $RPM_BUILD_DIR/%{name}-%{pkg_version}/src/sbin/xsc_set_rps_bynode.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 0755 $RPM_BUILD_DIR/%{name}-%{pkg_version}/src/sbin/xsc_set_affinity.sh $RPM_BUILD_ROOT/usr/sbin/
install -m 0755 $RPM_BUILD_DIR/%{name}-%{pkg_version}/src/sbin/xsc_nic_rename.sh $RPM_BUILD_ROOT/usr/sbin/

install -d $RPM_BUILD_ROOT/etc/depmod.d/
echo "override xsc_pci * weak-updates/xsc_pci" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
echo "override xsc_pci * extra/xsc_pci" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
echo "override xsc_eth * weak-updates/xsc_eth" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
echo "override xsc_eth * extra/xsc_eth" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
echo "override xsc_ib * weak-updates/xsc_rdma/hw" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-rdma.conf
echo "override xsc_ib * extra/xsc_rdma/hw" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}-rdma.conf

%preun
echo "/lib/modules/%{kernel}.%{_arch}/extra/xsc_net/xsc_eth.ko" >> /var/run/rpm-%{name}-modules.list
echo "/lib/modules/%{kernel}.%{_arch}/extra/xsc_pci/xsc_pci.ko" >> /var/run/rpm-%{name}-modules.list

%post
depmod -a %{kernel}.%{_arch} > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/xsc_pci/xsc_pci.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/xsc_net/xsc_eth.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi
if [ -e "/boot/initramfs-`uname -r`.img" ]; then  dracut -f > /dev/null 2>&1 ;fi
%postun
depmod -a %{kernel}.%{_arch} > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{name}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi
rm /var/run/rpm-%{name}-modules.list

%preun -n %{name}-rdma
echo "/lib/modules/%{kernel}.%{_arch}/extra/xsc_rdma/hw/xsc_ib.ko" >> /var/run/rpm-%{name}-rdma-modules.list

%post -n %{name}-rdma
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/xsc_rdma/hw/xsc_ib.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi

%postun -n %{name}-rdma
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{name}-rdma-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi
rm /var/run/rpm-%{name}-rdma-modules.list
if [ -e "/boot/initramfs-`uname -r`.img" ]; then  dracut -f > /dev/null 2>&1 ;fi
%files -n %{name}-rdma
/lib/modules/%{kernel}.%{_arch}/extra/xsc_rdma/hw/xsc_ib.ko
/etc/depmod.d/%{pkg}-rdma.conf
/etc/modules-load.d/xscale-rdma.conf

%files
%defattr(-,root,root)
/lib/modules/%{kernel}.%{_arch}/extra/xsc_net/xsc_eth.ko
/lib/modules/%{kernel}.%{_arch}/extra/xsc_pci/xsc_pci.ko
/etc/modules-load.d/xscale.conf
/etc/depmod.d/%{pkg}.conf
/usr/src/%{name}/drivers/xsc/include/rdma/peer_mem.h
/usr/sbin/mcr.sh
/usr/sbin/xsc_common_irq_affinity.sh
/usr/sbin/xsc_check_irq.sh
/usr/sbin/xsc_set_irq_affinity_bynode.sh
/usr/sbin/xsc_set_rps_bynode.sh
/usr/sbin/xsc_set_affinity.sh
/usr/sbin/xsc_nic_rename.sh



%changelog
* Mon Nov 11 2024 shengaoya <shengaoya@inspur.com> 0.1.2
- revise spec for koji
* Tue Feb 28 2023 Wangsc <wangsc@yunsilicon.com> 0.1.1
- using build.sh for multi kernels support
* Thu Sep 29 2022 Wangsc <wangsc@yunsilicon.com> 0.1.0
- add spec of rdma
